#pragma once

#include <Array.h>
#include <ReferenceCounter.h>
#include <Either.h>

#include "BiomGenerator.h"
#include "Chunk.h"

class DimensionGenerator : public virtual Framework::ReferenceCounter
{
private:
    Framework::RCArray<BiomGenerator> biomGenerators;
    Framework::Array<double> biomDistribution;
    const int dimensionId;

    BiomGenerator* zBiomGenerator( int seed, int x, int y );

protected:
    DimensionGenerator( int dimensionId );
    ~DimensionGenerator();
    void registerBiom( BiomGenerator* generator, double possibility );

public:
    Chunk* generateChunk( int seed, Game* zGame, int centerX, int centerY );
    Framework::Either<Block*, int> generateBlock( int seed, Game* zGame, Framework::Vec3<int> location );
    int getDimensionId() const;
    virtual Noise* zBiomNoise( int seed ) = 0;
};