#pragma once

#include "Event.h"
#include "Block.h"

#include <Vec3.h>

class LocationChangedEvent : public Event
{
private:
    const Block *block;
    const Framework::Vec3<int> oldPosition;
    const Framework::Vec3<int> newPosition;

public:
    LocationChangedEvent( Block *block, Framework::Vec3<int> oldPosition, Framework::Vec3<int> newPosition );

    Framework::Vec3<int> getOldPosition() const;
    Framework::Vec3<int> getNewPosition() const;
};